﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace CA2
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        string currentItem = String.Empty;
        int index = 0;

        ObservableCollection<Expensive> expenses;
        Random rng = new Random();
        public MainWindow()
        {
            InitializeComponent();


        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            var e1 = new Expensive()
            {
                Category = "Travel",
                Amount = 19.95m,
                ExpenseDate = new DateTime(2019, 6, 30)

            };
            var e2 = new Expensive()
            {
                Category = "Entertainment",
                Amount = 30.47m,
                ExpenseDate = new DateTime(2015, 7, 14)

            };
            var e3 = new Expensive()
            {
                Category = "Office",
                Amount = 2.99m,
                ExpenseDate = new DateTime(2020, 2, 27)

            };

          
            // add to a list
            expenses = new ObservableCollection<Expensive>();
            

            for (int i = 0; i < 4; i++)  // Displays random expenses
            {
                expenses.Add(getRandomExpensive());
            }
            


            // Display list in listbox
            LbxExpensives.ItemsSource = expenses;

           
        }

        private Expensive getRandomExpensive()
        {
            string[] categories = { "Office", "Travel", "Entertainment" };
            int randomNumber = rng.Next(0, 3);
            string category = categories[randomNumber];

            // get random amount
            randomNumber = rng.Next(1, 10001);
            decimal randomAmount = (decimal)randomNumber / 100;

            // get random date
            randomNumber = rng.Next(0, 31);
            DateTime randomDate = DateTime.Now.AddDays(-randomNumber); // give that date in the last 30 days

            Expensive e1 = new Expensive(randomAmount, randomDate, category);

            return e1;

        }

        private void AddButton_Click(object sender, RoutedEventArgs e)
        {
            

            currentItem = LbxExpensives.SelectedValue.ToString();
            index = LbxExpensives.SelectedIndex;
            SelectedActivities.Items.Add(currentItem);
            expenses?.RemoveAt(index);

            BlindNewList();


        }


        private void BlindNewList()
        {
            LbxExpensives.ItemsSource = null;
            LbxExpensives.ItemsSource = expenses;
        }

        private void TakeawayButton_Click(object sender, RoutedEventArgs e)
        {

            currentItem = SelectedActivities.SelectedValue.ToString();
            index = SelectedActivities.SelectedIndex;
            expenses.Add(currentItem);
            SelectedActivities.Items.RemoveAt( SelectedActivities.Items.IndexOf(SelectedActivities.SelectedItem));
            BlindNewList();
        }
    }
    
}
